transformers-0.4.1.0: Concrete functor and monad transformers

Portability | portable
Stability | experimental
Maintainer | ross@soi.city.ac.uk
Safe Haskell | Safe-Inferred

Control.Monad.Signatures

Description

Signatures for monad operations that require specialized lifting.

Synopsis

- type CallCC m a b = ((a -> m b) -> m a) -> m a
- type Catch e m a = m a -> (e -> m a) -> m a
- type Listen w m a = m a -> m (a, w)
- type Pass w m a = m (a, w -> w) -> m a

# Documentation

type CallCC m a b = ((a -> m b) -> m a) -> m a

Signature of the `callCC` operation, introduced in Control.Monad.Trans.Cont.

type Catch e m a = m a -> (e -> m a) -> m a

Signature of the `catchE` operation, introduced in Control.Monad.Trans.Except.

type Listen w m a = m a -> m (a, w)

Signature of the `listen` operation, introduced in Control.Monad.Trans.Writer.

type Pass w m a = m (a, w -> w) -> m a

Signature of the `pass` operation, introduced in Control.Monad.Trans.Writer.